comment*
======================================================================
        Scintilla Source editing component in static library
                      MASM32 compatible
                        v1.67 /rev.2/
                       [ASM lexer only]
======================================================================
*

IFNDEF _scintillainc
_scintillainc equ<1>

Sci_Init PROTO :DWORD ;//the function used for registering the Scintilla Class, the parameter is: hInstance of the Application

;//NOTE that the main proc in your ASM application MUST be named ProgramStartUp with no arguments i.e. :"ProgramStartUp PROC"

SCIFUNCTION TYPEDEF PROTO C :VARARG
SCIFUNCTIONPOINTER TYPEDEF PTR SCIFUNCTION
		
		;//--------------------------------------------------
		;//You can use the regular SendMessage Mechanism,
		;//but this is a method for Direct Access to 
		;//Scintilla Message Function. Is a faster and more
		;//reliable method than SendMessage function
		;//--------------------------------------------------
		IFNDEF SciFunction
			.data?
			SciFunction SCIFUNCTIONPOINTER ?
				
		ENDIF
		IFNDEF hDirectPointer
			.data?
			hDirectPointer DWORD ?
		ENDIF
		;//macro for Getting Direct Access to Scintilla's Message Function
		SciGetDirectAccess MACRO Scintilla_HWND
			    .code
				invoke SendMessage,Scintilla_HWND,SCI_GETDIRECTFUNCTION,0,0
				mov SciFunction,eax
				invoke SendMessage,Scintilla_HWND,SCI_GETDIRECTPOINTER,0,0
				mov hDirectPointer,eax
				EXITM <mov eax,TRUE>
		ENDM
		
		;//macro for sending messages to Scintilla with variable number of arguments
		SciMsg MACRO message_to_execute:VARARG
			
		.code
			EXITM <invoke SciFunction,hDirectPointer,message_to_execute>
		ENDM

comment*
====================================
    Scintilla Constants
====================================
*

INVALID_POSITION equ -1
SCI_START equ 2000
SCI_OPTIONAL_START equ 3000
SCI_LEXER_START equ 4000
SCI_ADDTEXT equ 2001
SCI_ADDSTYLEDTEXT equ 2002
SCI_INSERTTEXT equ 2003
SCI_CLEARALL equ 2004
SCI_CLEARDOCUMENTSTYLE equ 2005
SCI_GETLENGTH equ 2006
SCI_GETCHARAT equ 2007
SCI_GETCURRENTPOS equ 2008
SCI_GETANCHOR equ 2009
SCI_GETSTYLEAT equ 2010
SCI_REDO equ 2011
SCI_SETUNDOCOLLECTION equ 2012
SCI_SELECTALL equ 2013
SCI_SETSAVEPOINT equ 2014
SCI_GETSTYLEDTEXT equ 2015
SCI_CANREDO equ 2016
SCI_MARKERLINEFROMHANDLE equ 2017
SCI_MARKERDELETEHANDLE equ 2018
SCI_GETUNDOCOLLECTION equ 2019
SCWS_INVISIBLE equ 0
SCWS_VISIBLEALWAYS equ 1
SCWS_VISIBLEAFTERINDENT equ 2
SCI_GETVIEWWS equ 2020
SCI_SETVIEWWS equ 2021
SCI_POSITIONFROMPOINT equ 2022
SCI_POSITIONFROMPOINTCLOSE equ 2023
SCI_GOTOLINE equ 2024
SCI_GOTOPOS equ 2025
SCI_SETANCHOR equ 2026
SCI_GETCURLINE equ 2027
SCI_GETENDSTYLED equ 2028
SC_EOL_CRLF equ 0
SC_EOL_CR equ 1
SC_EOL_LF equ 2
SCI_CONVERTEOLS equ 2029
SCI_GETEOLMODE equ 2030
SCI_SETEOLMODE equ 2031
SCI_STARTSTYLING equ 2032
SCI_SETSTYLING equ 2033
SCI_GETBUFFEREDDRAW equ 2034
SCI_SETBUFFEREDDRAW equ 2035
SCI_SETTABWIDTH equ 2036
SCI_GETTABWIDTH equ 2121
SC_CP_UTF8 equ 65001
SC_CP_DBCS equ 1
SCI_SETCODEPAGE equ 2037
SCI_SETUSEPALETTE equ 2039
MARKER_MAX equ 31
SC_MARK_CIRCLE equ 0
SC_MARK_ROUNDRECT equ 1
SC_MARK_ARROW equ 2
SC_MARK_SMALLRECT equ 3
SC_MARK_SHORTARROW equ 4
SC_MARK_EMPTY equ 5
SC_MARK_ARROWDOWN equ 6
SC_MARK_MINUS equ 7
SC_MARK_PLUS equ 8
SC_MARK_VLINE equ 9
SC_MARK_LCORNER equ 10
SC_MARK_TCORNER equ 11
SC_MARK_BOXPLUS equ 12
SC_MARK_BOXPLUSCONNECTED equ 13
SC_MARK_BOXMINUS equ 14
SC_MARK_BOXMINUSCONNECTED equ 15
SC_MARK_LCORNERCURVE equ 16
SC_MARK_TCORNERCURVE equ 17
SC_MARK_CIRCLEPLUS equ 18
SC_MARK_CIRCLEPLUSCONNECTED equ 19
SC_MARK_CIRCLEMINUS equ 20
SC_MARK_CIRCLEMINUSCONNECTED equ 21
SC_MARK_BACKGROUND equ 22
SC_MARK_DOTDOTDOT equ 23
SC_MARK_ARROWS equ 24
SC_MARK_PIXMAP equ 25
SC_MARK_FULLRECT equ 26
SC_MARK_CHARACTER equ 10000
SC_MARKNUM_FOLDEREND equ 25
SC_MARKNUM_FOLDEROPENMID equ 26
SC_MARKNUM_FOLDERMIDTAIL equ 27
SC_MARKNUM_FOLDERTAIL equ 28
SC_MARKNUM_FOLDERSUB equ 29
SC_MARKNUM_FOLDER equ 30
SC_MARKNUM_FOLDEROPEN equ 31
SC_MASK_FOLDERS equ 0FE000000h
SCI_MARKERDEFINE equ 2040
SCI_MARKERSETFORE equ 2041
SCI_MARKERSETBACK equ 2042
SCI_MARKERADD equ 2043
SCI_MARKERDELETE equ 2044
SCI_MARKERDELETEALL equ 2045
SCI_MARKERGET equ 2046
SCI_MARKERNEXT equ 2047
SCI_MARKERPREVIOUS equ 2048
SCI_MARKERDEFINEPIXMAP equ 2049
SCI_MARKERADDSET equ 2466
SC_MARGIN_SYMBOL equ 0
SC_MARGIN_NUMBER equ 1
SCI_SETMARGINTYPEN equ 2240
SCI_GETMARGINTYPEN equ 2241
SCI_SETMARGINWIDTHN equ 2242
SCI_GETMARGINWIDTHN equ 2243
SCI_SETMARGINMASKN equ 2244
SCI_GETMARGINMASKN equ 2245
SCI_SETMARGINSENSITIVEN equ 2246
SCI_GETMARGINSENSITIVEN equ 2247
STYLE_DEFAULT equ 32
STYLE_LINENUMBER equ 33
STYLE_BRACELIGHT equ 34
STYLE_BRACEBAD equ 35
STYLE_CONTROLCHAR equ 36
STYLE_INDENTGUIDE equ 37
STYLE_LASTPREDEFINED equ 39
STYLE_MAX equ 127
SC_CHARSET_ANSI equ 0
SC_CHARSET_DEFAULT equ 1
SC_CHARSET_BALTIC equ 186
SC_CHARSET_CHINESEBIG5 equ 136
SC_CHARSET_EASTEUROPE equ 238
SC_CHARSET_GB2312 equ 134
SC_CHARSET_GREEK equ 161
SC_CHARSET_HANGUL equ 129
SC_CHARSET_MAC equ 77
SC_CHARSET_OEM equ 255
SC_CHARSET_RUSSIAN equ 204
SC_CHARSET_CYRILLIC equ 1251
SC_CHARSET_SHIFTJIS equ 128
SC_CHARSET_SYMBOL equ 2
SC_CHARSET_TURKISH equ 162
SC_CHARSET_JOHAB equ 130
SC_CHARSET_HEBREW equ 177
SC_CHARSET_ARABIC equ 178
SC_CHARSET_VIETNAMESE equ 163
SC_CHARSET_THAI equ 222
SC_CHARSET_8859_15 equ 1000
SCI_STYLECLEARALL equ 2050
SCI_STYLESETFORE equ 2051
SCI_STYLESETBACK equ 2052
SCI_STYLESETBOLD equ 2053
SCI_STYLESETITALIC equ 2054
SCI_STYLESETSIZE equ 2055
SCI_STYLESETFONT equ 2056
SCI_STYLESETEOLFILLED equ 2057
SCI_STYLERESETDEFAULT equ 2058
SCI_STYLESETUNDERLINE equ 2059
SC_CASE_MIXED equ 0
SC_CASE_UPPER equ 1
SC_CASE_LOWER equ 2
SCI_STYLESETCASE equ 2060
SCI_STYLESETCHARACTERSET equ 2066
SCI_STYLESETHOTSPOT equ 2409
SCI_SETSELFORE equ 2067
SCI_SETSELBACK equ 2068
SCI_SETCARETFORE equ 2069
SCI_ASSIGNCMDKEY equ 2070
SCI_CLEARCMDKEY equ 2071
SCI_CLEARALLCMDKEYS equ 2072
SCI_SETSTYLINGEX equ 2073
SCI_STYLESETVISIBLE equ 2074
SCI_GETCARETPERIOD equ 2075
SCI_SETCARETPERIOD equ 2076
SCI_SETWORDCHARS equ 2077
SCI_BEGINUNDOACTION equ 2078
SCI_ENDUNDOACTION equ 2079
INDIC_MAX equ 7
INDIC_PLAIN equ 0
INDIC_SQUIGGLE equ 1
INDIC_TT equ 2
INDIC_DIAGONAL equ 3
INDIC_STRIKE equ 4
INDIC_HIDDEN equ 5
INDIC_BOX equ 6
INDIC0_MASK equ 20h
INDIC1_MASK equ 40h
INDIC2_MASK equ 80h
INDICS_MASK equ 0E0h
SCI_INDICSETSTYLE equ 2080
SCI_INDICGETSTYLE equ 2081
SCI_INDICSETFORE equ 2082
SCI_INDICGETFORE equ 2083
SCI_SETWHITESPACEFORE equ 2084
SCI_SETWHITESPACEBACK equ 2085
SCI_SETSTYLEBITS equ 2090
SCI_GETSTYLEBITS equ 2091
SCI_SETLINESTATE equ 2092
SCI_GETLINESTATE equ 2093
SCI_GETMAXLINESTATE equ 2094
SCI_GETCARETLINEVISIBLE equ 2095
SCI_SETCARETLINEVISIBLE equ 2096
SCI_GETCARETLINEBACK equ 2097
SCI_SETCARETLINEBACK equ 2098
SCI_STYLESETCHANGEABLE equ 2099
SCI_AUTOCSHOW equ 2100
SCI_AUTOCCANCEL equ 2101
SCI_AUTOCACTIVE equ 2102
SCI_AUTOCPOSSTART equ 2103
SCI_AUTOCCOMPLETE equ 2104
SCI_AUTOCSTOPS equ 2105
SCI_AUTOCSETSEPARATOR equ 2106
SCI_AUTOCGETSEPARATOR equ 2107
SCI_AUTOCSELECT equ 2108
SCI_AUTOCSETCANCELATSTART equ 2110
SCI_AUTOCGETCANCELATSTART equ 2111
SCI_AUTOCSETFILLUPS equ 2112
SCI_AUTOCSETCHOOSESINGLE equ 2113
SCI_AUTOCGETCHOOSESINGLE equ 2114
SCI_AUTOCSETIGNORECASE equ 2115
SCI_AUTOCGETIGNORECASE equ 2116
SCI_USERLISTSHOW equ 2117
SCI_AUTOCSETAUTOHIDE equ 2118
SCI_AUTOCGETAUTOHIDE equ 2119
SCI_AUTOCSETDROPRESTOFWORD equ 2270
SCI_AUTOCGETDROPRESTOFWORD equ 2271
SCI_REGISTERIMAGE equ 2405
SCI_CLEARREGISTEREDIMAGES equ 2408
SCI_AUTOCGETTYPESEPARATOR equ 2285
SCI_AUTOCSETTYPESEPARATOR equ 2286
SCI_AUTOCSETMAXWIDTH equ 2208
SCI_AUTOCGETMAXWIDTH equ 2209
SCI_AUTOCSETMAXHEIGHT equ 2210
SCI_AUTOCGETMAXHEIGHT equ 2211
SCI_SETINDENT equ 2122
SCI_GETINDENT equ 2123
SCI_SETUSETABS equ 2124
SCI_GETUSETABS equ 2125
SCI_SETLINEINDENTATION equ 2126
SCI_GETLINEINDENTATION equ 2127
SCI_GETLINEINDENTPOSITION equ 2128
SCI_GETCOLUMN equ 2129
SCI_SETHSCROLLBAR equ 2130
SCI_GETHSCROLLBAR equ 2131
SCI_SETINDENTATIONGUIDES equ 2132
SCI_GETINDENTATIONGUIDES equ 2133
SCI_SETHIGHLIGHTGUIDE equ 2134
SCI_GETHIGHLIGHTGUIDE equ 2135
SCI_GETLINEENDPOSITION equ 2136
SCI_GETCODEPAGE equ 2137
SCI_GETCARETFORE equ 2138
SCI_GETUSEPALETTE equ 2139
SCI_GETREADONLY equ 2140
SCI_SETCURRENTPOS equ 2141
SCI_SETSELECTIONSTART equ 2142
SCI_GETSELECTIONSTART equ 2143
SCI_SETSELECTIONEND equ 2144
SCI_GETSELECTIONEND equ 2145
SCI_SETPRINTMAGNIFICATION equ 2146
SCI_GETPRINTMAGNIFICATION equ 2147
SC_PRINT_NORMAL equ 0
SC_PRINT_INVERTLIGHT equ 1
SC_PRINT_BLACKONWHITE equ 2
SC_PRINT_COLOURONWHITE equ 3
SC_PRINT_COLOURONWHITEDEFAULTBG equ 4
SCI_SETPRINTCOLOURMODE equ 2148
SCI_GETPRINTCOLOURMODE equ 2149
SCFIND_WHOLEWORD equ 2
SCFIND_MATCHCASE equ 4
SCFIND_WORDSTART equ 00100000h
SCFIND_REGEXP equ 00200000h
SCFIND_POSIX equ 00400000h
SCI_FINDTEXT equ 2150
SCI_FORMATRANGE equ 2151
SCI_GETFIRSTVISIBLELINE equ 2152
SCI_GETLINE equ 2153
SCI_GETLINECOUNT equ 2154
SCI_SETMARGINLEFT equ 2155
SCI_GETMARGINLEFT equ 2156
SCI_SETMARGINRIGHT equ 2157
SCI_GETMARGINRIGHT equ 2158
SCI_GETMODIFY equ 2159
SCI_SETSEL equ 2160
SCI_GETSELTEXT equ 2161
SCI_GETTEXTRANGE equ 2162
SCI_HIDESELECTION equ 2163
SCI_POINTXFROMPOSITION equ 2164
SCI_POINTYFROMPOSITION equ 2165
SCI_LINEFROMPOSITION equ 2166
SCI_POSITIONFROMLINE equ 2167
SCI_LINESCROLL equ 2168
SCI_SCROLLCARET equ 2169
SCI_REPLACESEL equ 2170
SCI_SETREADONLY equ 2171
SCI_NULL equ 2172
SCI_CANPASTE equ 2173
SCI_CANUNDO equ 2174
SCI_EMPTYUNDOBUFFER equ 2175
SCI_UNDO equ 2176
SCI_CUT equ 2177
SCI_COPY equ 2178
SCI_PASTE equ 2179
SCI_CLEAR equ 2180
SCI_SETTEXT equ 2181
SCI_GETTEXT equ 2182
SCI_GETTEXTLENGTH equ 2183
SCI_GETDIRECTFUNCTION equ 2184
SCI_GETDIRECTPOINTER equ 2185
SCI_SETOVERTYPE equ 2186
SCI_GETOVERTYPE equ 2187
SCI_SETCARETWIDTH equ 2188
SCI_GETCARETWIDTH equ 2189
SCI_SETTARGETSTART equ 2190
SCI_GETTARGETSTART equ 2191
SCI_SETTARGETEND equ 2192
SCI_GETTARGETEND equ 2193
SCI_REPLACETARGET equ 2194
SCI_REPLACETARGETRE equ 2195
SCI_SEARCHINTARGET equ 2197
SCI_SETSEARCHFLAGS equ 2198
SCI_GETSEARCHFLAGS equ 2199
SCI_CALLTIPSHOW equ 2200
SCI_CALLTIPCANCEL equ 2201
SCI_CALLTIPACTIVE equ 2202
SCI_CALLTIPPOSSTART equ 2203
SCI_CALLTIPSETHLT equ 2204
SCI_CALLTIPSETBACK equ 2205
SCI_CALLTIPSETFORE equ 2206
SCI_CALLTIPSETFOREHLT equ 2207
SCI_VISIBLEFROMDOCLINE equ 2220
SCI_DOCLINEFROMVISIBLE equ 2221
SCI_WRAPCOUNT equ 2235
SC_FOLDLEVELBASE equ 400h
SC_FOLDLEVELWHITEFLAG equ 1000h
SC_FOLDLEVELHEADERFLAG equ 2000h
SC_FOLDLEVELBOXHEADERFLAG equ 4000h
SC_FOLDLEVELBOXFOOTERFLAG equ 8000h
SC_FOLDLEVELCONTRACTED equ 10000h
SC_FOLDLEVELUNINDENT equ 20000h
SC_FOLDLEVELNUMBERMASK equ 0FFFh
SCI_SETFOLDLEVEL equ 2222
SCI_GETFOLDLEVEL equ 2223
SCI_GETLASTCHILD equ 2224
SCI_GETFOLDPARENT equ 2225
SCI_SHOWLINES equ 2226
SCI_HIDELINES equ 2227
SCI_GETLINEVISIBLE equ 2228
SCI_SETFOLDEXPANDED equ 2229
SCI_GETFOLDEXPANDED equ 2230
SCI_TOGGLEFOLD equ 2231
SCI_ENSUREVISIBLE equ 2232
SC_FOLDFLAG_LINEBEFORE_EXPANDED equ 0002h
SC_FOLDFLAG_LINEBEFORE_CONTRACTED equ 0004h
SC_FOLDFLAG_LINEAFTER_EXPANDED equ 0008h
SC_FOLDFLAG_LINEAFTER_CONTRACTED equ 0010h
SC_FOLDFLAG_LEVELNUMBERS equ 0040h
SC_FOLDFLAG_BOX equ 0001h
SCI_SETFOLDFLAGS equ 2233
SCI_ENSUREVISIBLEENFORCEPOLICY equ 2234
SCI_SETTABINDENTS equ 2260
SCI_GETTABINDENTS equ 2261
SCI_SETBACKSPACEUNINDENTS equ 2262
SCI_GETBACKSPACEUNINDENTS equ 2263
SC_TIME_FOREVER equ 10000000
SCI_SETMOUSEDWELLTIME equ 2264
SCI_GETMOUSEDWELLTIME equ 2265
SCI_WORDSTARTPOSITION equ 2266
SCI_WORDENDPOSITION equ 2267
SC_WRAP_NONE equ 0
SC_WRAP_WORD equ 1
SC_WRAP_CHAR equ 2
SCI_SETWRAPMODE equ 2268
SCI_GETWRAPMODE equ 2269
SC_WRAPVISUALFLAG_NONE equ 0000h
SC_WRAPVISUALFLAG_END equ 0001h
SC_WRAPVISUALFLAG_START equ 0x0002
SCI_SETWRAPVISUALFLAGS equ 2460
SCI_GETWRAPVISUALFLAGS equ 2461
SC_WRAPVISUALFLAGLOC_DEFAULT equ 0000h
SC_WRAPVISUALFLAGLOC_END_BY_TEXT equ 0001h
SC_WRAPVISUALFLAGLOC_START_BY_TEXT equ 0002h
SCI_SETWRAPVISUALFLAGSLOCATION equ 2462
SCI_GETWRAPVISUALFLAGSLOCATION equ 2463
SCI_SETWRAPSTARTINDENT equ 2464
SCI_GETWRAPSTARTINDENT equ 2465
SC_CACHE_NONE equ 0
SC_CACHE_CARET equ 1
SC_CACHE_PAGE equ 2
SC_CACHE_DOCUMENT equ 3
SCI_SETLAYOUTCACHE equ 2272
SCI_GETLAYOUTCACHE equ 2273
SCI_SETSCROLLWIDTH equ 2274
SCI_GETSCROLLWIDTH equ 2275
SCI_TEXTWIDTH equ 2276
SCI_SETENDATLASTLINE equ 2277
SCI_GETENDATLASTLINE equ 2278
SCI_TEXTHEIGHT equ 2279
SCI_SETVSCROLLBAR equ 2280
SCI_GETVSCROLLBAR equ 2281
SCI_APPENDTEXT equ 2282
SCI_GETTWOPHASEDRAW equ 2283
SCI_SETTWOPHASEDRAW equ 2284
SCI_TARGETFROMSELECTION equ 2287
SCI_LINESJOIN equ 2288
SCI_LINESSPLIT equ 2289
SCI_SETFOLDMARGINCOLOUR equ 2290
SCI_SETFOLDMARGINHICOLOUR equ 2291
SCI_LINEDOWN equ 2300
SCI_LINEDOWNEXTEND equ 2301
SCI_LINEUP equ 2302
SCI_LINEUPEXTEND equ 2303
SCI_CHARLEFT equ 2304
SCI_CHARLEFTEXTEND equ 2305
SCI_CHARRIGHT equ 2306
SCI_CHARRIGHTEXTEND equ 2307
SCI_WORDLEFT equ 2308
SCI_WORDLEFTEXTEND equ 2309
SCI_WORDRIGHT equ 2310
SCI_WORDRIGHTEXTEND equ 2311
SCI_HOME equ 2312
SCI_HOMEEXTEND equ 2313
SCI_LINEEND equ 2314
SCI_LINEENDEXTEND equ 2315
SCI_DOCUMENTSTART equ 2316
SCI_DOCUMENTSTARTEXTEND equ 2317
SCI_DOCUMENTEND equ 2318
SCI_DOCUMENTENDEXTEND equ 2319
SCI_PAGEUP equ 2320
SCI_PAGEUPEXTEND equ 2321
SCI_PAGEDOWN equ 2322
SCI_PAGEDOWNEXTEND equ 2323
SCI_EDITTOGGLEOVERTYPE equ 2324
SCI_CANCEL equ 2325
SCI_DELETEBACK equ 2326
SCI_TAB equ 2327
SCI_BACKTAB equ 2328
SCI_NEWLINE equ 2329
SCI_FORMFEED equ 2330
SCI_VCHOME equ 2331
SCI_VCHOMEEXTEND equ 2332
SCI_ZOOMIN equ 2333
SCI_ZOOMOUT equ 2334
SCI_DELWORDLEFT equ 2335
SCI_DELWORDRIGHT equ 2336
SCI_LINECUT equ 2337
SCI_LINEDELETE equ 2338
SCI_LINETRANSPOSE equ 2339
SCI_LINEDUPLICATE equ 2404
SCI_LOWERCASE equ 2340
SCI_UPPERCASE equ 2341
SCI_LINESCROLLDOWN equ 2342
SCI_LINESCROLLUP equ 2343
SCI_DELETEBACKNOTLINE equ 2344
SCI_HOMEDISPLAY equ 2345
SCI_HOMEDISPLAYEXTEND equ 2346
SCI_LINEENDDISPLAY equ 2347
SCI_LINEENDDISPLAYEXTEND equ 2348
SCI_HOMEWRAP equ 2349
SCI_HOMEWRAPEXTEND equ 2450
SCI_LINEENDWRAP equ 2451
SCI_LINEENDWRAPEXTEND equ 2452
SCI_VCHOMEWRAP equ 2453
SCI_VCHOMEWRAPEXTEND equ 2454
SCI_LINECOPY equ 2455
SCI_MOVECARETINSIDEVIEW equ 2401
SCI_LINELENGTH equ 2350
SCI_BRACEHIGHLIGHT equ 2351
SCI_BRACEBADLIGHT equ 2352
SCI_BRACEMATCH equ 2353
SCI_GETVIEWEOL equ 2355
SCI_SETVIEWEOL equ 2356
SCI_GETDOCPOINTER equ 2357
SCI_SETDOCPOINTER equ 2358
SCI_SETMODEVENTMASK equ 2359
EDGE_NONE equ 0
EDGE_LINE equ 1
EDGE_BACKGROUND equ 2
SCI_GETEDGECOLUMN equ 2360
SCI_SETEDGECOLUMN equ 2361
SCI_GETEDGEMODE equ 2362
SCI_SETEDGEMODE equ 2363
SCI_GETEDGECOLOUR equ 2364
SCI_SETEDGECOLOUR equ 2365
SCI_SEARCHANCHOR equ 2366
SCI_SEARCHNEXT equ 2367
SCI_SEARCHPREV equ 2368
SCI_LINESONSCREEN equ 2370
SCI_USEPOPUP equ 2371
SCI_SELECTIONISRECTANGLE equ 2372
SCI_SETZOOM equ 2373
SCI_GETZOOM equ 2374
SCI_CREATEDOCUMENT equ 2375
SCI_ADDREFDOCUMENT equ 2376
SCI_RELEASEDOCUMENT equ 2377
SCI_GETMODEVENTMASK equ 2378
SCI_SETFOCUS equ 2380
SCI_GETFOCUS equ 2381
SCI_SETSTATUS equ 2382
SCI_GETSTATUS equ 2383
SCI_SETMOUSEDOWNCAPTURES equ 2384
SCI_GETMOUSEDOWNCAPTURES equ 2385
SC_CURSORNORMAL equ -1
SC_CURSORWAIT equ 4
SCI_SETCURSOR equ 2386
SCI_GETCURSOR equ 2387
SCI_SETCONTROLCHARSYMBOL equ 2388
SCI_GETCONTROLCHARSYMBOL equ 2389
SCI_WORDPARTLEFT equ 2390
SCI_WORDPARTLEFTEXTEND equ 2391
SCI_WORDPARTRIGHT equ 2392
SCI_WORDPARTRIGHTEXTEND equ 2393
VISIBLE_SLOP equ 0x01
VISIBLE_STRICT equ 0x04
SCI_SETVISIBLEPOLICY equ 2394
SCI_DELLINELEFT equ 2395
SCI_DELLINERIGHT equ 2396
SCI_SETXOFFSET equ 2397
SCI_GETXOFFSET equ 2398
SCI_CHOOSECARETX equ 2399
SCI_GRABFOCUS equ 2400
CARET_SLOP equ 0x01
CARET_STRICT equ 0x04
CARET_JUMPS equ 0x10
CARET_EVEN equ 0x08
SCI_SETXCARETPOLICY equ 2402
SCI_SETYCARETPOLICY equ 2403
SCI_SETPRINTWRAPMODE equ 2406
SCI_GETPRINTWRAPMODE equ 2407
SCI_SETHOTSPOTACTIVEFORE equ 2410
SCI_SETHOTSPOTACTIVEBACK equ 2411
SCI_SETHOTSPOTACTIVEUNDERLINE equ 2412
SCI_SETHOTSPOTSINGLELINE equ 2421
SCI_PARADOWN equ 2413
SCI_PARADOWNEXTEND equ 2414
SCI_PARAUP equ 2415
SCI_PARAUPEXTEND equ 2416
SCI_POSITIONBEFORE equ 2417
SCI_POSITIONAFTER equ 2418
SCI_COPYRANGE equ 2419
SCI_COPYTEXT equ 2420
SC_SEL_STREAM equ 0
SC_SEL_RECTANGLE equ 1
SC_SEL_LINES equ 2
SCI_SETSELECTIONMODE equ 2422
SCI_GETSELECTIONMODE equ 2423
SCI_GETLINESELSTARTPOSITION equ 2424
SCI_GETLINESELENDPOSITION equ 2425
SCI_LINEDOWNRECTEXTEND equ 2426
SCI_LINEUPRECTEXTEND equ 2427
SCI_CHARLEFTRECTEXTEND equ 2428
SCI_CHARRIGHTRECTEXTEND equ 2429
SCI_HOMERECTEXTEND equ 2430
SCI_VCHOMERECTEXTEND equ 2431
SCI_LINEENDRECTEXTEND equ 2432
SCI_PAGEUPRECTEXTEND equ 2433
SCI_PAGEDOWNRECTEXTEND equ 2434
SCI_STUTTEREDPAGEUP equ 2435
SCI_STUTTEREDPAGEUPEXTEND equ 2436
SCI_STUTTEREDPAGEDOWN equ 2437
SCI_STUTTEREDPAGEDOWNEXTEND equ 2438
SCI_WORDLEFTEND equ 2439
SCI_WORDLEFTENDEXTEND equ 2440
SCI_WORDRIGHTEND equ 2441
SCI_WORDRIGHTENDEXTEND equ 2442
SCI_SETWHITESPACECHARS equ 2443
SCI_SETCHARSDEFAULT equ 2444
SCI_AUTOCGETCURRENT equ 2445
SCI_ALLOCATE equ 2446
SCI_TARGETASUTF8 equ 2447
SCI_SETLENGTHFORENCODE equ 2448
SCI_ENCODEDFROMUTF8 equ 2449
SCI_FINDCOLUMN equ 2456
SCI_GETCARETSTICKY equ 2457
SCI_SETCARETSTICKY equ 2458
SCI_TOGGLECARETSTICKY equ 2459
SCI_SETPASTECONVERTENDINGS equ 2467
SCI_GETPASTECONVERTENDINGS equ 2468
SCI_SELECTIONDUPLICATE equ 2469
SCI_STARTRECORD equ 3001
SCI_STOPRECORD equ 3002
SCI_SETLEXER equ 4001
SCI_GETLEXER equ 4002
SCI_COLOURISE equ 4003
SCI_SETPROPERTY equ 4004
KEYWORDSET_MAX equ 8
SCI_SETKEYWORDS equ 4005
SCI_SETLEXERLANGUAGE equ 4006
SCI_LOADLEXERLIBRARY equ 4007
SCI_GETPROPERTY equ 4008
SCI_GETPROPERTYEXPANDED equ 4009
SCI_GETPROPERTYINT equ 4010
SCI_GETSTYLEBITSNEEDED equ 4011
SC_MOD_INSERTTEXT equ 1h
SC_MOD_DELETETEXT equ 2h
SC_MOD_CHANGESTYLE equ 4h
SC_MOD_CHANGEFOLD equ 8h
SC_PERFORMED_USER equ 10h
SC_PERFORMED_UNDO equ 20h
SC_PERFORMED_REDO equ 40h
SC_MULTISTEPUNDOREDO equ 80h
SC_LASTSTEPINUNDOREDO equ 100h
SC_MOD_CHANGEMARKER equ 200h
SC_MOD_BEFOREINSERT equ 400h
SC_MOD_BEFOREDELETE equ 800h
SC_MULTILINEUNDOREDO equ 1000h
SC_MODEVENTMASKALL equ 1FFFh
SCEN_CHANGE equ 768
SCEN_SETFOCUS equ 512
SCEN_KILLFOCUS equ 256
SCK_DOWN equ 300
SCK_UP equ 301
SCK_LEFT equ 302
SCK_RIGHT equ 303
SCK_HOME equ 304
SCK_END equ 305
SCK_PRIOR equ 306
SCK_NEXT equ 307
SCK_DELETE equ 308
SCK_INSERT equ 309
SCK_ESCAPE equ 7
SCK_BACK equ 8
SCK_TAB equ 9
SCK_RETURN equ 13
SCK_ADD equ 310
SCK_SUBTRACT equ 311
SCK_DIVIDE equ 312
SCMOD_NORM equ 0
SCMOD_SHIFT equ 1
SCMOD_CTRL equ 2
SCMOD_ALT equ 4
SCN_STYLENEEDED equ 2000
SCN_CHARADDED equ 2001
SCN_SAVEPOINTREACHED equ 2002
SCN_SAVEPOINTLEFT equ 2003
SCN_MODIFYATTEMPTRO equ 2004
SCN_KEY equ 2005
SCN_DOUBLECLICK equ 2006
SCN_UPDATEUI equ 2007
SCN_MODIFIED equ 2008
SCN_MACRORECORD equ 2009
SCN_MARGINCLICK equ 2010
SCN_NEEDSHOWN equ 2011
SCN_PAINTED equ 2013
SCN_USERLISTSELECTION equ 2014
SCN_URIDROPPED equ 2015
SCN_DWELLSTART equ 2016
SCN_DWELLEND equ 2017
SCN_ZOOM equ 2018
SCN_HOTSPOTCLICK equ 2019
SCN_HOTSPOTDOUBLECLICK equ 2020
SCN_CALLTIPCLICK equ 2021
SCN_AUTOCSELECTION equ 2022


comment*	These structures are defined to be exactly the same shape as the Win32
			CHARRANGE, TEXTRANGE, FINDTEXTEX, FORMATRANGE, and NMHDR structs.
			So older code that treats Scintilla as a RichEdit will work.
*

CharacterRange STRUCT
	cpMin DWORD ?
	cpMax DWORD ?
CharacterRange ENDS

SCCHARACTERRANGE equ <CharacterRange>

TextRange STRUCT
	chrg CharacterRange <>
	lpstrText DWORD ?
TextRange ENDS

SCTEXTRANGE equ <TextRange>


TextToFind STRUCT
	chrg CharacterRange <>
	lpstrText DWORD ?
	chrgText CharacterRange <>
TextToFind ENDS

SCTEXTTOFIND equ <TextToFind>

NotifyHeader STRUCT
	hwndFrom DWORD ?
	idFrom DWORD ?
	code DWORD ?
NotifyHeader ENDS

SCNOTIFYHEADER equ <NotifyHeader>


SCNOTIFICATION struct
	hdr        NMHDR <>
	position   DWORD ?	; SCN_STYLENEEDED, SCN_MODIFIED, SCN_DWELLSTART, SCN_DWELLEND
	ch_        DWORD ?	; SCN_CHARADDED, SCN_KEY
	modifiers  DWORD ?	; SCN_KEY
	modificationType DWORD ?	; SCN_MODIFIED
	text       DWORD ?	; SCN_MODIFIED, SCN_USERLISTSELECTION, SCN_AUTOCSELECTION
	len        DWORD ?	; SCN_MODIFIED
	linesAdded DWORD ?	; SCN_MODIFIED
	message    DWORD ?	; SCN_MACRORECORD
	wParam     DWORD ?	; SCN_MACRORECORD
	lParam     DWORD ?	; SCN_MACRORECORD
	line       DWORD ?	; SCN_MODIFIED
	foldLevelNow  DWORD	? ; SCN_MODIFIED
	foldLevelPrev DWORD	? ; SCN_MODIFIED
	margin     DWORD ?	; SCN_MARGINCLICK
	listType   DWORD ?	; SCN_USERLISTSELECTION
	x          DWORD ?	; SCN_DWELLSTART, SCN_DWELLEND
	y          DWORD ?	; SCN_DWELLSTART, SCN_DWELLEND
SCNOTIFICATION ends

IFDEF INCLUDE_DEPRECATED_FEATURES

	SCI_SETCARETPOLICY equ 2369
	CARET_CENTER equ 02h
	CARET_XEVEN equ 08h
	CARET_XJUMPS equ 10h
	SCN_POSCHANGED equ 2012
	SCN_CHECKBRACE equ 2007
	
ENDIF


comment*
====================================
    Assembler Lexer constants
====================================
*

SCLEX_ASM                 equ 34
SCE_ASM_DEFAULT           equ 0
SCE_ASM_COMMENT           equ 1
SCE_ASM_NUMBER            equ 2
SCE_ASM_STRING            equ 3
SCE_ASM_OPERATOR          equ 4
SCE_ASM_IDENTIFIER        equ 5
SCE_ASM_CPUINSTRUCTION    equ 6
SCE_ASM_MATHINSTRUCTION   equ 7
SCE_ASM_REGISTER          equ 8
SCE_ASM_DIRECTIVE         equ 9
SCE_ASM_DIRECTIVEOPERAND  equ 10
SCE_ASM_COMMENTBLOCK      equ 11
SCE_ASM_CHARACTER         equ 12
SCE_ASM_STRINGEOL         equ 13
SCE_ASM_EXTINSTRUCTION    equ 14


ELSE
echo --------------------------------------------
echo WARNING Duplicate include file Scintilla.inc
echo --------------------------------------------
ENDIF
